/////////////////////////////////////////
// Cool cube thing in psuedo-3D        //
// Created by Dave Havok               //
// Perfected and commented at 11:23 PM //
// Monday, October 23rd, 2000          //
/////////////////////////////////////////

#define SAVE_SCREEN          // Save all the screen data

#include <nostub.h>          // So you can run it without a shell (Hurray)
#include <all.h>             // All the includes for TI-GCC

int _ti89;                   // Compile for the 89

// Below are all the variables used in the program. It's not exactly the most convenient method, but it's all I have for now.

static int x11 = 60, y11 = 30, x12 = 95, y12 = 30, x13 = 95, y13 = 65, x14 = 60, y14 = 65, z1 = 35;
static int x21 = 60, y21 = 30, x22 = 95, y22 = 30, x23 = 95, y23 = 65, x24 = 60, y24 = 65, z2 = 70;

// Below this are the "camera" coordinates, so the object can be drawn from more than a single viewing position.

static int camx = 0, camy = 0, camz = 0;  // With these values of zero, it would be as though someone were standing right in the center of 


void Calc()
{
 // I restated all the variables used so the would stay the same no matter how many times you ran the program, because if I didn't, they would keep changing. So if you're going to change any of the values I declared as static ints, you'll have to change them down here, too.
 
 x11 = 60, y11 = 30, x12 = 95, y12 = 30, x13 = 95, y13 = 65, x14 = 60, y14 = 65, z1 = 35;
 x21 = 60, y21 = 30, x22 = 95, y22 = 30, x23 = 95, y23 = 65, x24 = 60, y24 = 65, z2 = 70;
 camx = 0, camy = 0, camz = 0
 
 // These calculate the new drawing position according to the camera values.
 
 // These are all the (simple) calculations to determine the new x and y coordinates based on z. One tenth of z may not be the true constant, however. But it'll work for now.
 
 x11 = x11 + z1;
 x12 = x12 - z1;
 x13 = x13 - z1;
 x14 = x14 + z1;
 y11 = y11 + z1;
 y12 = y12 + z1;
 y13 = y13 - z1;
 y14 = y14 - z1;
 x21 = x21 + z2;
 x22 = x22 - z2;
 x23 = x23 - z2;
 x24 = x24 + z2;
 y21 = y21 + z2;
 y22 = y22 + z2;
 y23 = y23 - z2;
 y24 = y24 - z2;
}

void _main()
{
 ClrScr();                                   // Clear the screen (Duh)
 Calc();                                     // Make all the calculations
 DrawLine(x11,y11,x12,y12,A_NORMAL);         // Draw all the lines of the cube...
 DrawLine(x12,y12,x13,y13,A_NORMAL);
 DrawLine(x13,y13,x14,y14,A_NORMAL);
 DrawLine(x14,y14,x11,y11,A_NORMAL);
 DrawLine(x21,y21,x22,y22,A_NORMAL);
 DrawLine(x22,y22,x23,y23,A_NORMAL);
 DrawLine(x23,y23,x24,y24,A_NORMAL);
 DrawLine(x24,y24,x21,y21,A_NORMAL);
 DrawLine(x11,y11,x21,y21,A_NORMAL);
 DrawLine(x12,y12,x22,y22,A_NORMAL);
 DrawLine(x13,y13,x23,y23,A_NORMAL);
 DrawLine(x14,y14,x24,y24,A_NORMAL);         // ...
 ngetchx();                                  // Wait until a key is pressed before exiting
 return 0;
}
